'TinyTools_v101.bas
'03/03/2011 bugfix in [displayExamples] branch
'TinyTools_v1.bas
'03/03/2011
'All content free to use
'Syntax data file is "syn.tny"




' Check for data file exists
' If no data file, close program
fileName$="syn.tny"

    if not(FileExists(fileName$)) then
        notice "No data file detected"
        notice "Program ending"
        end
    end if

'
'
' DATAFILE FORMAT - Chr$(0) separated values:
'   1) List item
'   2) Syntax definition
'   3) Help filename
'   4) Example filename
'
' Open data file and fill array

    dim syn$(300)                       'array is DIMd oversize
    open fileName$ for input as #in
    i = 1
    while eof(#in) = 0
        line input #in, in$
        syn$(i) = in$

        i = i + 1
    wend
    TotalEntries = i -1
    close #in

'
' Begin program GUI
'
'
nomainwin
'print DefaultDir$
Title$ = "Tiny Tools"

[programWindow]
    WindowWidth=130
    WindowHeight=70
    UpperLeftX=DisplayWidth-140
    UpperLeftY=10

    button #main.syn    "Syntax", [openSyntaxWindow], UL,  0,  0, 98, 20
    bmpbutton #main.hlp "Help.bmp", [help], UL, 98, 0
    button #main.col    "Colors", [colors], UL,  0, 20,  60, 20
    button #main.ascii  "ASCII", [ascii], UL, 63, 20,  60, 20

    open Title$ for dialog as #main     'THIS IS MAIN WINDOW
    isOpenMain = 1                      'flag file is open
    #main "trapclose [quit.main]"

    wait


[xtras]
    exFileName$ = word$(syn$(index), 4, chr$(0))
    if exFileName$ = "" then createCode = 1
    gosub [displayExamples]
    if createCode then createCode = 0
    wait

[colors]
    gosub [makeColorChart]
    wait

[ascii]
    chartName$ = "asciiChart.txt"
    isChart = 1
    m = .75             ' m is multiplier to adjust window size to suit contents

    gosub [displayChart]
    isChart = 0
    wait


[openSyntaxWindow]                      'THIS IS LISTBOX WINDOW
    if isOpenSyn then wait              'trap if window is open
    WindowWidth=130
    WindowHeight=600
    UpperLeftX=DisplayWidth-140
    UpperLeftY=90

    listbox #syn.list syn$(), [displaySelection], 1, 1, 120, 560

    open "List box" for window_nf as #syn       'LISTBOX WINDOW = #syn
    isOpenSyn = 1                       'flag window is open
    #syn "trapclose [quit.syn]"
    #syn.list "singleclickselect"
    #syn "font arial 9"

    wait

    [quit.syn]
    if isOpenSyn then isOpenSyn = 0
    close #syn
    wait

[displaySelection]                      'Branch here on single click

    print #syn.list, "selectionindex? index"

    'Define a window to show syntax definition
    WindowWidth=300
    WindowHeight=110
    ' use statictext control to display syntax definition
    statictext #def.st "", 10, 30, 250, 60

    button #def.default "Help", [openHelpWindow], UL, 1, 1, 50, 20
    button #def.xtras   "Examples", [xtras], UL, 55, 1, 70, 20

    open "Syntax" for dialog_nf_modal as #def
    isOpenDef = 1                       'flag window is open
    #def "trapclose [close.def]"
    #def "font arial 9"

    'now display the syntax definition
    #def.st word$(syn$(index), 2, chr$(0))

    wait

    [close.def]                         'close syntax definition window
    if isOpenDef then isOpenDef = 0
    close #def

    wait


[quit.color]
    if isOpenColor then close #c: isOpenColor = 0
    wait

[quit.main]
    if isOpenColor then close #c :isOpenColor = 0
    if isOpenChart then close #chart :isOpenChart = 0
    if isOpenDef then close #def:isOpenDef = 0
    if isOpenSyn then close #syn:isOpenSyn = 0
    if isOpenExam then close #exam:isOpenExam = 0
    if isOpenHlp then close #h:isOpenHlp = 0
    if isOpenMain then isOpenMain = 0
    close #main
    end


'Get name of help file for selection.
'If no help file available, notify the user.
'
[openHelpWindow]
    print #syn.list, "selectionindex? index"
    hlpfileName$ = word$(syn$(index), 3, chr$(0))
    if hlpfileName$ = "" then
        notice "Help not yet available for this command."
    else
        gosub [getHlp]
    end if

    wait


[getHlp]
    'open the file in "hlpfiles" subfolder for this item
    open "hlpfiles\" + hlpfileName$ for input as #hlp

    'The following construct reads the first character of a help file name.
    'If first character is a number, that number is used as a multiplier
    'for window size. If no number, default uses 1 as multiplier.
    select case left$(hlpfileName$, 1)
        case "2"
            m = 1.5                     ' m = multiplier for winddow height
        case "3"
            m = 2
        case "4"
            m = 2.5
        case "5"                        ' case 5 files use chart display window
            m = 2.5
            isChart = 1                 ' flag a chart file is open
            chartName$ = hlpfileName$   ' retain file name for this use
        case else
            m = 1                       ' default window size
    end select

    obj$ = input$(#hlp, lof(#hlp))      ' obj$ = file's contents

    close #hlp                          ' close file

    if isChart AND isOpenChart then notice "Chart window is open";chr$(13);_
                               "Only one Chart window may be open at a time.";chr$(13);_
                               "Please close current Chart window.";chr$(13);_
                               chr$(13);"(Color chart window may remain open.)":wait

    if isChart then
        gosub [displayChart]
      else
        gosub [displayHlp]
    end if

    return




[displayHlp]
    WindowWidth = 300
    WindowHeight = m*300                ' height can vary

    ' The statictext control provides automatic word-wrap.
    ' The height of the window is adjusted to suit the content.
    statictext #obj.st "", 5, 5, 285, m*280 ' height can vary


    open "Description" for dialog_modal as #obj
    isOpenObj = 1                       ' flag window is open
    #obj "trapclose [close.obj]"
    'help windows are designed for this font:
    #obj "font ms_sans_serif 8"

    #obj.st obj$                        ' display file in statictext control
    wait

    [close.obj]
    if isOpenObj then isOpenObj = 0
    close #obj
    return                              ' return after closing modal window

[displayChart]
    WindowWidth = m*150                 ' width can vary for content
    WindowHeight = 600
    UpperLeftX = DisplayWidth -(m*220)  ' adj position relative to width
    UpperLeftY = 90

    button #chart.close "Close", [close.chart], UL, 5, 5
    ' The texteditor is used to provide scroll bars for content
    ' that is too long to fit in a normal help window.
    TexteditorColor$ = "white"
    texteditor #chart.txted  5, 40, m*140, 500

    open "Chart" for window_nf as #chart
    isOpenChart = 1                     ' flag window is open
    #chart "trapclose [close.chart]"
    #chart "font arial 8"
    if chartName$ = "asciiChart.txt" then #chart "font arial 9"

    open "hlpfiles\" + chartName$ for input as #fin

    txt$ = input$(#fin, lof(#fin))
    close #fin

    #chart.txted txt$                   ' print information to texteditor
    #chart.txted "!origin 1 1"          ' put cursor at top of window
    if isChart then isChart = 0
    return

    [close.chart]
    if isOpenChart then isOpenChart = 0
    close #chart
    wait

[displayExamples]
    if not(createCode) then

        ' Open the file in the examples\ subfolder for this item
        open "examples\" + exFileName$ for input as #exam
        exam$ = input$(#exam, lof(#exam))
        close #exam
    else
        exam$ = ""
    end if

    WindowWidth = 350
    WindowHeight = 350

' The following not needed with text window and inset texteditor:
'    TexteditorColor$ = "lightgray"  'won't work with inset editor
'    texteditor #exam.txted 5, 5, 285, 250

    menu #exam.edit, "edit"
    'add a help menu for code safe
    menu #exam, "&Help", "&Create a code sample", [saveCode]

    open "Examples" for text as #exam
'    open "Examples" for window_nf as #exam         'other choices
'    open "Examples" for dialog_modal as #exam      ' "
    isOpenExam = 1                       ' flag window is open
    #exam "!trapclose [close.exam]"
    #exam "!font arial 8"

    #exam exam$ 

    wait

    [saveCode]
    notice "Save code";chr$(13);_
            "Paste code sample here, or type your code into editor.";chr$(13);_
            "Use File>Save As and navigate to the examples\ ";chr$(13);_
            "subfolder to save the code. Save file as 'exCommandName.txt',";chr$(13);_
            "where CommandName is the list item name. ";chr$(13);chr$(13);_
            "Open the database program and edit the list";chr$(13);_
            "item line to add the file name to the end of ";chr$(13);_
            "the line, being sure to also add the chr$(0)";chr$(13);_
            "before the file name. Run the database program";chr$(13);_
            "to update the database. Check to make sure the";chr$(13);_
            "example was correctly added."
    wait

    [close.exam]
    if createCode then createCode = 0
    if isOpenExam then isOpenExam = 0
    close #exam
    return



'********************************************
'FUNCTIONS, SUBS AND ROUTINES
'********************************************

' Check if datafile exists
function FileExists(fileName$)
    ' returns true(any number) or false(0)
    dim FileExistsInfo$(1,1)
    files "", fileName$, FileExistsInfo$()
    FileExists = val(FileExistsInfo$(0,0))
end function

[makeColorChart]
    WindowWidth=130
    WindowHeight=600

    TextboxColor$ = "yellow"
    textbox #c.c1, 5, 5, 100, 20
    statictext #c.st1, "yellow", 5, 22, 100, 15

    TextboxColor$ = "brown"
    textbox #c.c2, 5, 40, 100, 20
    statictext #c.st, "brown", 5, 57, 100, 15

    TextboxColor$ = "red"
    textbox #c.c3, 5, 75, 100, 20
    statictext #c.st3, "red", 5, 92, 100, 15

    TextboxColor$ = "darkred"
    textbox #c.c4, 5, 110, 100, 20
    statictext #c.st4, "darkred", 5, 127, 100, 15

    TextboxColor$ = "pink"
    textbox #c.c5, 5, 145, 100, 20
    statictext #c.st5, "pink", 5, 162, 100, 15

    TextboxColor$ = "darkpink"
    textbox #c.c6, 5, 180, 100, 20
    statictext #c.st6, "darkpink", 5, 197, 100, 15

    TextboxColor$ = "blue"
    textbox #c.c7, 5, 215, 100, 20
    statictext #c.st7, "blue", 5, 232, 100, 15

    TextboxColor$ = "darkblue"
    textbox #c.c8, 5, 250, 100, 20
    statictext #c.st8, "darkblue", 5, 267, 100, 15

    TextboxColor$ = "green"
    textbox #c.c9, 5, 285, 100, 20
    statictext #c.st9, "green", 5, 302, 100, 15

    TextboxColor$ = "darkgreen"
    textbox #c.c10, 5, 320, 100, 20
    statictext #c.st10, "darkgreen", 5, 337, 100, 15

    TextboxColor$ = "cyan"
    textbox #c.c11, 5, 355, 100, 20
    statictext #c.st11, "cyan", 5, 372, 100, 15

    TextboxColor$ = "darkcyan"
    textbox #c.c12, 5, 390, 100, 20
    statictext #c.st12, "darkcyan", 5, 407, 100, 15

    TextboxColor$ = "white"
    textbox #c.c13, 5, 425, 100, 20
    statictext #c.st13, "white", 5, 442, 100, 15

    TextboxColor$ = "black"
    textbox #c.c14, 5, 460, 100, 20
    statictext #c.st14, "black", 5, 477, 100, 15

    TextboxColor$ = "lightgray"
    textbox #c.c15, 5, 495, 100, 20
    statictext #c.st15, "lightgray", 5, 512, 100, 15

    TextboxColor$ = "darkgray"
    textbox #c.c16, 5, 530, 100, 20
    statictext #c.st16, "darkgray", 5, 547, 100, 15

    open "Colors" for window as #c
    #c "trapclose [quit.color]"
    isOpenColor = 1
    return

[help]
    open "ReadMe.txt" for input as #hep
    txt$ = input$(#hep, lof(#hep))
    close #hep

    WindowWidth=400
    WindowHeight=400

    open "Help" for text as #h
    #h "!trapclose [quit.help]"
    isOpenHlp = 1
    #h "!font arial 9"

    #h txt$

    #h "!origin 1 1"
    wait
    [quit.help]
    close #h
    isOpenHlp = 0
    wait
